searchNodes=[{"type":"module","title":"segmented_cache","doc":"segmented_cache is a key/value pairs cache library implemented in rotating segments. For more information, see the README, and the function documentation.","ref":"segmented_cache.html"},{"type":"function","title":"segmented_cache.delete_entry/2","doc":"Delete an entry in all ets segments Might raise a telemetry error if the request fails: name: [segmented_cache, Name, delete_error] measurements: \#{} metadata: \#{name =&gt; atom(), delete_type =&gt; entry, value =&gt; Key, class =&gt; throw | error | exit, reason =&gt; term()}","ref":"segmented_cache.html#delete_entry/2"},{"type":"function","title":"segmented_cache.delete_pattern/2","doc":"Delete a pattern in all ets segments Might raise a telemetry error if the request fails: name: [segmented_cache, Name, delete_error] measurements: \#{} metadata: \#{name =&gt; atom(), delete_type =&gt; pattern, value =&gt; Pattern, class =&gt; throw | error | exit, reason =&gt; term()}","ref":"segmented_cache.html#delete_pattern/2"},{"type":"function","title":"segmented_cache.get_entry/2","doc":"Get the entry for Key in cache Raises telemetry span name: [segmented_cache, Name, request, _] start metadata: \#{name =&gt; atom()} stop metadata: \#{name =&gt; atom(), hit =&gt; boolean()}","ref":"segmented_cache.html#get_entry/2"},{"type":"function","title":"segmented_cache.is_member/2","doc":"Check if Key is cached Raises telemetry span name: [segmented_cache, Name, request, _] start metadata: \#{name =&gt; atom()} stop metadata: \#{name =&gt; atom(), hit =&gt; boolean()}","ref":"segmented_cache.html#is_member/2"},{"type":"function","title":"segmented_cache.merge_entry/3","doc":"Merge a new entry into an existing one, or add it at the front if none is found. Race conditions considerations: Two writers: compare_and_swap will ensure they both succeed sequentially Any writers and the cleaner: under fifo, the writer modifies the record in place and doesn't need to be concerned with rotation. Under lru, the same considerations than for a put_entry_front apply.","ref":"segmented_cache.html#merge_entry/3"},{"type":"function","title":"segmented_cache.put_entry/3","doc":"Add an entry to the first table in the segments. Possible race conditions: Two writers: another process might attempt to put a record at the same time. It this case, both writers will attempt ets:insert_new , resulting in only one of them succeeding. The one that fails, will retry three times a compare_and_swap , attempting to merge the values and ensuring no data is lost. One worker and the cleaner: there's a chance that by the time we insert in the ets table, this table is not the first anymore because the cleaner has taken action and pushed it behind. Two writers and the cleaner: a mix of the previous, it can happen that two writers can attempt to put a record at the same time, but exactly in-between, the cleaner rotates the tables, resulting in the first writter inserting in the table that immediately becomes the second, and the latter writter inserting in the recently treated as first, shadowing the previous. To treat the data race with the cleaner, after a successful insert, we re-check the index, and if it has changed, we restart the whole operation again: we can be sure that no more rotations will be triggered in a while, so the second round will be final. Strategy considerations: under a fifo strategy, no other writes can happen, but under a lru strategy, many other workers might attemp to move a record forward. In this case, the forwarding movement doesn't modify the record, and therefore the compare_and_swap operation should succeed at once; then, once the record is in the front, all other workers shouldn't be attempting to move it.","ref":"segmented_cache.html#put_entry/3"},{"type":"function","title":"segmented_cache.start/1","doc":"See also: start_link/2 .","ref":"segmented_cache.html#start/1"},{"type":"function","title":"segmented_cache.start/2","doc":"See also: start_link/2 .","ref":"segmented_cache.html#start/2"},{"type":"function","title":"segmented_cache.start_link/1","doc":"See also: start_link/2 .","ref":"segmented_cache.html#start_link/1"},{"type":"function","title":"segmented_cache.start_link/2","doc":"Start and link a cache entity in the local node Name must be an atom. Then the cache will be identified by the pair {segmented_cache, Name} , and an entry in persistent_term will be created and the worker will join a pg group of the same name. Opts is a map containing the configuration. scope is a pg scope. Defaults to pg . strategy can be fifo or lru. Default is fifo . segment_num is the number of segments for the cache. Default is 3 ttl is the live, in minutes, of _each_ segment. Default is 480 , i.e., 8 hours. merger_fun is a function that, given a conflict, takes in order the old and new values and applies a merging strategy. See the merger_fun(term()) type.","ref":"segmented_cache.html#start_link/2"},{"type":"type","title":"segmented_cache.key/0","doc":"","ref":"segmented_cache.html#t:key/0"},{"type":"type","title":"segmented_cache.merger_fun/1","doc":"","ref":"segmented_cache.html#t:merger_fun/1"},{"type":"type","title":"segmented_cache.name/0","doc":"","ref":"segmented_cache.html#t:name/0"},{"type":"type","title":"segmented_cache.opts/0","doc":"","ref":"segmented_cache.html#t:opts/0"},{"type":"type","title":"segmented_cache.scope/0","doc":"","ref":"segmented_cache.html#t:scope/0"},{"type":"type","title":"segmented_cache.strategy/0","doc":"","ref":"segmented_cache.html#t:strategy/0"},{"type":"type","title":"segmented_cache.value/0","doc":"","ref":"segmented_cache.html#t:value/0"},{"type":"extras","title":"Overview","doc":"segmented_cache is a key-value cache library implemented in rotating segments.","ref":"readme.html"},{"type":"extras","title":"Overview - How does it work","doc":"It uses a coarse-grained strategy, that is, it keeps a set of ETS tables that are periodically rotated, and on rotation, the last table is cleared. It supports diverse eviction strategies, it takes advantage of modern OTP functionality like persistent_term or atomics , and it is instrumented with telemetry . The cache spawns a process cleaner responsible for periodically cleaning and rotating the tables. It also automatically creates a pg group to sync caches in a cluster. Note that this process will be the owner of the ets tables, so proper care of its supervision must be ensued.","ref":"readme.html#how-does-it-work"},{"type":"extras","title":"Overview - Why another caching library","doc":"Like many things in computing, it depends on the use-case: Time-to-live Very often, the ttl of an entry isn't required to be strictly enforced, and it can instead be allocated in &quot;buckets&quot;, where the actual ttl is allowed to be anything between pre-configured buckets. This simplifies book-keeping, as only the life of the buckets needs to be tracked, instead of a fine-grained per-entry book-keeping. Extensible values Entries can have any type of values, but upon inserts of the same key, a strategy is often needed to decide the final value: whether we want to always keep the latest, always keep the first, or merge them in some way, a custom-tailored callback can be given to decide. A common pattern can be, for example, to keep maps with metadata, and to use fun maps:merge/2 as the callback for conflict resolution. Concurrency This implementation is specially tailored for massively concurrent cache lookups and inserts: many caches in Erlang read from an ets table with read_concurrency but serialise inserts through a gen_server , which, in high insert bursts, becomes a bottleneck, not considering duplicates inserts that infinitely many workers might request. Other caches serialise read and writes through a gen_server that keeps the data in a map in its state: this is not only a bottleneck but a source of garbage, as the map is copied on every mutation. Here instead, the cache uses a –bunch of– ets table with read_concurrency , write_concurrency , and decentralized_counters , to maximise concurrent throughput of all read and writes. It also stores references to the buckets, the index, and the merge strategy, using persistent_term , to maximise performance. Garbage collection and shared memory All operations hove been carefully written following the latest OTP efficiency guide , including maps operations that improve sharing, avoiding unnecessary copying from ETS tables, inline list functions, use atomics and persistent_term as in this guide . Instrumentation These days, all modern services must be instrumented. This cache library helps follow the RED method –Rate, Errors, Duration–: that is, lookup operations raise telemetry events with name [segmented_cache, Name, request] with information whether there was a hit or not ( hit := boolean() ), and the time the lookup took, in microseconds ( time := integer() ). With this, we can aggregate the total Rate, and extract the proportion of cache misses, or Errors, while knowing the Duration of the lookups. See the documentation for details.","ref":"readme.html#why-another-caching-library"},{"type":"extras","title":"Overview - Configuration","doc":"strategy can be fifo or lru. Default is fifo . segment_num is the number of segments for the cache. Default is 3 ttl is the live, in minutes, of each segment. Default is 480 , i.e., 8 hours. Can also be a tuple of {erlang:time_unit(), non_neg_integer()} merger_fun is a callback to resolve conflicts, that takes two conflicting values and returns the final value to be stored. This function takes, in order, the value already present in the table, and the one that is being now inserted. For example, if maps are being used as values, merger_fun can be fun maps:merge/2 .","ref":"readme.html#configuration"},{"type":"extras","title":"Design Notes","doc":"Here are the key points of the design:","ref":"design_notes.html"},{"type":"extras","title":"Design Notes - Cache state","doc":"The cache records are stored in multiple ETS tables called segments , stored in a tuple to improve access times. There's one current table pointed at by an index, stored in an atomic . The persistent_term module is used to store the cache state, which contains the tuple of segments and the atomic reference. It's initialised just once, and it never changes after that. The atomic value is changing, but most importantly: changing in a lock-free manner. Writes are always done at the current table. Reads iterate through all of them in order, starting from the current one.","ref":"design_notes.html#cache-state"},{"type":"extras","title":"Design Notes - TTL implementation","doc":"Tables are rotated periodically and data from the last table is dropped. ttl is not 100% accurate, as a record can be inserted during rotation and therefore live one segment less that expected: we can treat the ttl as a warranty that a record will live less than ttl but at least ttl - ttl/N where N is the number of segments (ETS tables). There's a gen_server process responsible for the table rotation (see Cache state notes for more details).","ref":"design_notes.html#ttl-implementation"},{"type":"extras","title":"Design Notes - LRU implementation","doc":"On segmented_cache:is_member/2 and segmented_cache:get_entry/2 calls, the record is reinserted in the current ETS table.","ref":"design_notes.html#lru-implementation"},{"type":"extras","title":"Design Notes - Distribution","doc":"In a distributed environment, cache is populated independently on every node. However, we must ensure that on deletion the cache record is removed on all the nodes (and from all the ETS tables, see LRU implementation notes ) There's a gen_server process responsible for ETS tables rotation (see TTL implementation notes ) The same process is reused to implement asynchronous cache record deletion on other nodes in the cluster. In order to simplify discovery of these gen_server processes on other nodes, they all are added into a dedicated pg group.","ref":"design_notes.html#distribution"},{"type":"extras","title":"License","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS Copyright 2021, Erlang Solutions LTD. Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"}]